# This script gets the count of reads at each variant site in a given sample
# It uses the file generated from File_S1.R

import pysam
import collections
import os


###start in this directory
#####will need to move/copy all bam files and indices into a new directory, will require renaming b/c all are 'accepted_hits.bam'
mySNPdir='sec_variants_bamfiles_thinned/'
os.mkdir(mySNPdir)


##make an array of file names, take all the files ending in m (bam?) for our directory
bamfiles=[]
dirlist=os.listdir(".")
for file in dirlist:
   if file.endswith('bam'):
      bamfiles.append(file)

#bamfilename="50_50_st2_1_sim.bam"
#bamfile = pysam.Samfile(bamfilename, 'rb')

# SNP file is from assign_SNPs.R script
SNPfile='SNPs_by_transcript.txt'

##loop over the individual bam files
for bamfilename in bamfiles:
    print(bamfilename)
    bamfile = pysam.Samfile(bamfilename, 'rb')  ##read in the file using pysam

    mysnps=open(SNPfile) 
    oldtranscript="blah"
    #snpsout= "50_50_st2_unthinned.snps" ##mySNPdir+bamfilename+".snps"  ###make an output file name
    #outfile=open(snpsout,'w')  ###open our file
    snpsout= mySNPdir+bamfilename+"thinned.snps"  ###make an output file name
    outfile=open(snpsout,'w')  ###open our file

    for snp in mysnps:
        a=snp.split() 
        chr=a[0] 
        pos=int(a[1])
        transcript=a[6]
        if not transcript == oldtranscript:

            print(transcript)       
            mycounter = collections.Counter()
            oldtranscript = transcript 
        
        for pileupcolumn in bamfile.pileup(chr,pos-1,pos+1):  ###look at this SNP position (made this loop over the positions either side to get to the SNP position)
            if (1+pileupcolumn.pos) == pos:
                base_counts = {'A':0, 'C':0, 'G':0, 'T':0, 'N':0, 'D':0}
                for pileupread in pileupcolumn.pileups: 
                    readname=pileupread.alignment.query_name   ##get name of read
                    if not pileupread.is_del and not pileupread.is_refskip:              
                        if  mycounter[readname] ==0:  #  True: 
                            base_counts[pileupread.alignment.query_sequence[pileupread.query_position]] += 1   ##update count with this base                        
                        mycounter[readname] += 1    
                    else:
                        base_counts['D'] += 1
                myout=chr+" "+ str(pileupcolumn.tid)+" " +str(pos)+ " "+str(pileupcolumn.pos)+" "+a[2]+" "+a[3]+" "+str(base_counts['A'])+" "+str(base_counts['C'])+" "+str(base_counts['G'])+" "+str(base_counts['T'])+" "+str(base_counts['N'])+" "+str(base_counts['D'])+"\n"   ##output the data for this base
                outfile.write(myout)
bamfile.close()
outfile.close()
mysnps.close()

