#This script is used to merge and normalize the data after organizing the read counts for each species using File_S3.R

setwd("~/Desktop/mau_sec_new_deletions/")

mau_sec_hybrid_inds_3<-read.table("mau_sec_hybrids_inds_new_deletions.out",sep="\t",head=TRUE,as.is=TRUE)
mau_par3<-read.table("mau_to_mau_and_mau_to_sec_inds_new_deletion.out",sep="\t",head=TRUE,as.is=TRUE)
sec_par3<-read.table("sec_to_mau_and_sec_to_sec_inds_new_deletion.out",sep="\t",head=TRUE,as.is=TRUE)

tmp<-mau_par3[,28:87]
colnames(tmp)<-paste("mau_",colnames(tmp),sep="")
mau_sec_inds_3<-cbind(mau_sec_hybrid_inds_3, tmp)
tmp<-sec_par3[,28:87]
colnames(tmp)<-paste("sec_",colnames(tmp),sep="")
mau_sec_inds<-cbind(mau_sec_inds_3,tmp)

#all_inds<-cbind(sim_mau_inds, sim_sec_inds, mau_sec_inds)

write.table(file="mau_sec_all_inds_new_deletion.out",mau_sec_inds,sep="\t",quote=FALSE, row.names=FALSE)
mau_sec_inds<-read.table("mau_sec_all_inds_new_deletion.out",sep="\t",head=TRUE,as.is=TRUE)

## normalizing mau_sec cross to upper quartile medians
#label ref and alt columns (this will be useful for applying median -- upper quartile normalization later)
mau_ref_labs<-grepl("mau_ref",colnames(mau_sec_inds)) & !grepl("per_snp",colnames(mau_sec_inds))
mau_alt_labs<-grepl("mau_alt",colnames(mau_sec_inds)) & !grepl("per_snp",colnames(mau_sec_inds))

#computing row sum for every two rows
tmp_rowSum<-mau_sec_inds[,mau_ref_labs] + mau_sec_inds[,mau_alt_labs]  #sapply(split.default(tmp_per_snp, 0:119 %/% 2), rowSums)
#finding the median of counts for each individual
#tmp_median<-t(colMedians(as.matrix(tmp_rowSum), na.rm = TRUE))
upper_quantile<-t(apply(as.matrix(tmp_rowSum),2,quantile,p=0.75,na.rm=TRUE))
#replicate each median value to divide ref and alt columns by
#tmp2_median<-rep(tmp_median,each=2)
upper_quantile_2<-rep(upper_quantile,each=2)
#computing constant to multiply all counts by
#taking the average of median counts/gene
mean_75quantile<-rowMeans(upper_quantile)
#applying scaling factor (the mean upper quantile/upper quantile of each sample)
mau_mapped_norm_1<-apply(mau_sec_inds[,mau_ref_labs | mau_alt_labs],1,function(x){
  x/(upper_quantile_2/mean_75quantile)
})

mau_mapped_norm<-t(mau_mapped_norm_1)
#test
#colMedians(sim_mapped_norm[,1:30*2]+sim_mapped_norm[,(1:30*2)-1])
quantile(mau_mapped_norm[,1:30*2]+mau_mapped_norm[,(1:30*2)-1],2,p=0.75,na.rm=TRUE)
##applying the normalized columns to original data frame
mau_sec_inds[,mau_ref_labs | mau_alt_labs]<-mau_mapped_norm

###normalizing sec reads to upper quartile
#label ref and alt columns
sec_ref_labs<-grepl("sec_ref",colnames(mau_sec_inds)) & !grepl("per_snp",colnames(mau_sec_inds))
sec_alt_labs<-grepl("sec_alt",colnames(mau_sec_inds)) & !grepl("per_snp",colnames(mau_sec_inds))
#computing row sum for every two rows
tmp_sec_rowSum<-mau_sec_inds[,sec_ref_labs] + mau_sec_inds[,sec_alt_labs]
#calculating upper quartile for each individual
upper_quantile<-t(apply(as.matrix(tmp_sec_rowSum),2,quantile,p=0.75,na.rm=TRUE))
#replicate each median value to divide ref and alt columns by
upper_quantile_2<-rep(upper_quantile,each=2)
#computing constant to multiply all counts by
#taking the average of median counts/gene
mean_75quantile<-rowMeans(upper_quantile)
#applying scaling factor (the mean upper quantile/upper quantile of each sample)
sec_mapped_norm_1<-apply(mau_sec_inds[,sec_ref_labs | sec_alt_labs],1,function(x){
  x/(upper_quantile_2/mean_75quantile)
})

sec_mapped_norm<-t(sec_mapped_norm_1)
#colMedians(sim_mapped_norm[,1:30*2]+sim_mapped_norm[,(1:30*2)-1])
quantile(sec_mapped_norm[,1:30*2]+sec_mapped_norm[,(1:30*2)-1],2,p=0.75,na.rm=TRUE)
##applying the normalized columns to original data frame
mau_sec_inds[,sec_ref_labs | sec_alt_labs]<-sec_mapped_norm
#write out normalized table
write.table(file="mau_sec_norm_inds_new_deletions.out",mau_sec_inds,sep="\t",quote=FALSE, row.names=FALSE)




